Subject: Re: UART configuration problems

From: Ormund Williams <[email-masked]>
Date: Fri, 12 Jan 2001 21:30:24 -0500

Navin Boppuri wrote:
>
> Hello everyone,
>
> I am trying to interface a MAX3100 uart to an SPI controller on the MPC823.
> I have a functional SPI driver running. The transmit part of the UART works
> just fine. I am able to transmit characters at 9600 8N1 baud. The problem
> arises when I do a receive. The uart documentation says that the internal
> fifo is 8 word long. But I notice that the FIFO is able to store only 8
> characters. For example, if I transmit the characters
>             abcdefghijklmnopqrstuvwxyz
>
> The uart shows only "yz" in its buffers. The other 24 characters are lost. I
> noticed that 8 charaters are written in the buffer. It first writes
> "abcdefgh" and then overwrites that with "ijklmnop" and so on. The uart
> generates an irq interrupt whenever there is incoming data. I do not see why
> the buffer is not big enough.
>
The MAX3100 is working as designed, the 8 word fifo can only hold 8
characters the other bits in the word hold the parity, framing error,
etc.  If the fifo overflows all characters are lost.  The following is
from page 5 and 7 of the datasheet.

"Read data from a 16-bit register that holds the oldest
data from the receive FIFO, the received parity data,
and the logic level at the CTS input pin. This register
also contains a bit that is the framing error in normal
operation and a receive-activity indicator in shutdown."

"Receive data is stored in an 8-word FIFO. The FIFO is
cleared if it overflows."

> Can someone give me some insight into this problem? What do I need to do to
> correct this?
>
Read the data before the fifo overflows.

--
Ormund

** Sent via the linuxppc-embedded mail list. See http://lists.linuxppc.org/